SystemOrganization addCategory: #'OMeta2-Exp'!

OMeta2 subclass: #LSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2-Exp'!

!LSystem commentStamp: 'sn 9/14/2014 01:22' prior: 0!
"Koch snowflake"

|match|
match := 'F++F++F'.
1 to: 3 do:[:each|
	match := LSystem matchAll: match with: #start.
].	
"match inspect."
LSystem draw: match.!

!LSystem class methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:13'!
draw: aString

	|pen sym lineLength angle|

	pen := Pen new.
	lineLength := 10.
	angle := 60.

	1 to: aString size do:[:each|
		sym := (aString at: each) asString.
		((sym = 'F') or:[(sym = 'G')]) ifTrue:[
			pen go: lineLength.
			].
	
		(sym = '+')  ifTrue:[ pen turn: angle].
		(sym = '-')  ifTrue:[ pen turn: (-1)*angle].
	].! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:21'!
applyRule=
	"F":n -> [self rule] 
| symbols
! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/13/2014 19:06'!
example=
	"t":n <spaces (letter | digit)*>:all ->[{n. all}]! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:02'!
rule
	^'F-F++F-F'! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:20'!
start=
	applyRule*:n ->[self stringFromCollection: n] 

! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/13/2014 20:42'!
stringFromCollection: aCol

	|str|
	str := ''.
	aCol do:[:each| str := str, each asString].
	^str! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:21'!
symbols=
	("-" | "+"):n -> [n] ! !
